$: << ::File.expand_path("../lib", __FILE__)

require "rubygems"
require "redis_safe_queue"

QUEUE = RedisSafeQueue.new(
  :redis => Redis.new,
  :redis_prefix => "fnordbar",
  :queue_id => rand(8**16).to_s(36),
  :timeout => 60
)

10_000.times do |i|
  QUEUE.push("fnord-#{rand(123)}")
end

$processed = 0

10.times { Thread.new {

  QUEUE.work do |job|
    $processed += 1
  end

  QUEUE.finish do
    puts "queue finished, processed #{$processed} jobs on 10 threads"
    exit 0
  end

} }

loop do
  puts "size: #{QUEUE.size}, processed: #{$processed}, iterations: #{QUEUE.iterations}"
  sleep 1
end
